From f5a5bf18e3049e21f2b2cc62f7cab7fb892bf3a6 Mon Sep 17 00:00:00 2001
From: Tomas Vondra <tomas.vondra@postgresql.org>
Date: Tue, 7 Nov 2023 19:07:48 +0100
Subject: [PATCH v3 3/4] simplify comparetup_index_brin

---
 src/backend/utils/sort/tuplesortvariants.c | 11 ++++-------
 1 file changed, 4 insertions(+), 7 deletions(-)

diff --git a/src/backend/utils/sort/tuplesortvariants.c b/src/backend/utils/sort/tuplesortvariants.c
index 525cc01b474..9b3a70e6ccf 100644
--- a/src/backend/utils/sort/tuplesortvariants.c
+++ b/src/backend/utils/sort/tuplesortvariants.c
@@ -1719,15 +1719,12 @@ static int
 comparetup_index_brin(const SortTuple *a, const SortTuple *b,
 					  Tuplesortstate *state)
 {
-	BrinTuple  *tuple1;
-	BrinTuple  *tuple2;
+	Assert(TuplesortstateGetPublic(state)->haveDatum1);
 
-	tuple1 = &((BrinSortTuple *) (a->tuple))->tuple;
-	tuple2 = &((BrinSortTuple *) (b->tuple))->tuple;
-
-	if (tuple1->bt_blkno > tuple2->bt_blkno)
+	if (DatumGetUInt32(a->datum1) > DatumGetUInt32(b->datum1))
 		return 1;
-	else if (tuple1->bt_blkno < tuple2->bt_blkno)
+
+	if (DatumGetUInt32(a->datum1) < DatumGetUInt32(b->datum1))
 		return -1;
 
 	/* silence compilers */
-- 
2.41.0

